git-am.shon commit Merge branch 'jc/git-add--interactive' (6f38e03)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5USAGE='[--signoff] [--dotest=<dir>] [--utf8] [--binary] [--3way]
   6  [--interactive] [--whitespace=<option>] <mbox>...
   7  or, when resuming [--skip | --resolved]'
   8. git-sh-setup
   9
  10git var GIT_COMMITTER_IDENT >/dev/null || exit
  11
  12stop_here () {
  13    echo "$1" >"$dotest/next"
  14    exit 1
  15}
  16
  17stop_here_user_resolve () {
  18    if [ -n "$resolvemsg" ]; then
  19            echo "$resolvemsg"
  20            stop_here $1
  21    fi
  22    cmdline=$(basename $0)
  23    if test '' != "$interactive"
  24    then
  25        cmdline="$cmdline -i"
  26    fi
  27    if test '' != "$threeway"
  28    then
  29        cmdline="$cmdline -3"
  30    fi
  31    if test '.dotest' != "$dotest"
  32    then
  33        cmdline="$cmdline -d=$dotest"
  34    fi
  35    echo "When you have resolved this problem run \"$cmdline --resolved\"."
  36    echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
  37
  38    stop_here $1
  39}
  40
  41go_next () {
  42        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
  43                "$dotest/patch" "$dotest/info"
  44        echo "$next" >"$dotest/next"
  45        this=$next
  46}
  47
  48cannot_fallback () {
  49        echo "$1"
  50        echo "Cannot fall back to three-way merge."
  51        exit 1
  52}
  53
  54fall_back_3way () {
  55    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
  56
  57    rm -fr "$dotest"/patch-merge-*
  58    mkdir "$dotest/patch-merge-tmp-dir"
  59
  60    # First see if the patch records the index info that we can use.
  61    git-apply -z --index-info "$dotest/patch" \
  62        >"$dotest/patch-merge-index-info" &&
  63    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
  64    git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
  65    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
  66    git-write-tree >"$dotest/patch-merge-base+" ||
  67    cannot_fallback "Patch does not record usable index information."
  68
  69    echo Using index info to reconstruct a base tree...
  70    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
  71        git-apply $binary --cached <"$dotest/patch"
  72    then
  73        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
  74        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
  75    else
  76        cannot_fallback "Did you hand edit your patch?
  77It does not apply to blobs recorded in its index."
  78    fi
  79
  80    test -f "$dotest/patch-merge-index" &&
  81    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
  82    orig_tree=$(cat "$dotest/patch-merge-base") &&
  83    rm -fr "$dotest"/patch-merge-* || exit 1
  84
  85    echo Falling back to patching base and 3-way merge...
  86
  87    # This is not so wrong.  Depending on which base we picked,
  88    # orig_tree may be wildly different from ours, but his_tree
  89    # has the same set of wildly different changes in parts the
  90    # patch did not touch, so resolve ends up canceling them,
  91    # saying that we reverted all those changes.
  92
  93    git-merge-resolve $orig_tree -- HEAD $his_tree || {
  94            if test -d "$GIT_DIR/rr-cache"
  95            then
  96                git-rerere
  97            fi
  98            echo Failed to merge in the changes.
  99            exit 1
 100    }
 101}
 102
 103prec=4
 104rloga=am
 105dotest=.dotest sign= utf8= keep= skip= interactive= resolved= binary= ws= resolvemsg=
 106
 107while case "$#" in 0) break;; esac
 108do
 109        case "$1" in
 110        -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
 111        dotest=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
 112        -d|--d|--do|--dot|--dote|--dotes|--dotest)
 113        case "$#" in 1) usage ;; esac; shift
 114        dotest="$1"; shift;;
 115
 116        -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
 117        --interacti|--interactiv|--interactive)
 118        interactive=t; shift ;;
 119
 120        -b|--b|--bi|--bin|--bina|--binar|--binary)
 121        binary=t; shift ;;
 122
 123        -3|--3|--3w|--3wa|--3way)
 124        threeway=t; shift ;;
 125        -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
 126        sign=t; shift ;;
 127        -u|--u|--ut|--utf|--utf8)
 128        utf8=t; shift ;;
 129        -k|--k|--ke|--kee|--keep)
 130        keep=t; shift ;;
 131
 132        -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
 133        resolved=t; shift ;;
 134
 135        --sk|--ski|--skip)
 136        skip=t; shift ;;
 137
 138        --whitespace=*)
 139        ws=$1; shift ;;
 140
 141        --resolvemsg=*)
 142        resolvemsg=$(echo "$1" | sed -e "s/^--resolvemsg=//"); shift ;;
 143
 144        --reflog-action=*)
 145        rloga=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
 146
 147        --)
 148        shift; break ;;
 149        -*)
 150        usage ;;
 151        *)
 152        break ;;
 153        esac
 154done
 155
 156# If the dotest directory exists, but we have finished applying all the
 157# patches in them, clear it out.
 158if test -d "$dotest" &&
 159   last=$(cat "$dotest/last") &&
 160   next=$(cat "$dotest/next") &&
 161   test $# != 0 &&
 162   test "$next" -gt "$last"
 163then
 164   rm -fr "$dotest"
 165fi
 166
 167if test -d "$dotest"
 168then
 169        case "$#,$skip$resolved" in
 170        0,*t*)
 171                # Explicit resume command and we do not have file, so
 172                # we are happy.
 173                : ;;
 174        0,)
 175                # No file input but without resume parameters; catch
 176                # user error to feed us a patch from standard input
 177                # when there is already .dotest.  This is somewhat
 178                # unreliable -- stdin could be /dev/null for example
 179                # and the caller did not intend to feed us a patch but
 180                # wanted to continue unattended.
 181                tty -s
 182                ;;
 183        *)
 184                false
 185                ;;
 186        esac ||
 187        die "previous dotest directory $dotest still exists but mbox given."
 188        resume=yes
 189else
 190        # Make sure we are not given --skip nor --resolved
 191        test ",$skip,$resolved," = ,,, ||
 192                die "Resolve operation not in progress, we are not resuming."
 193
 194        # Start afresh.
 195        mkdir -p "$dotest" || exit
 196
 197        git-mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
 198                rm -fr "$dotest"
 199                exit 1
 200        }
 201
 202        # -b, -s, -u, -k and --whitespace flags are kept for the
 203        # resuming session after a patch failure.
 204        # -3 and -i can and must be given when resuming.
 205        echo "$binary" >"$dotest/binary"
 206        echo " $ws" >"$dotest/whitespace"
 207        echo "$sign" >"$dotest/sign"
 208        echo "$utf8" >"$dotest/utf8"
 209        echo "$keep" >"$dotest/keep"
 210        echo 1 >"$dotest/next"
 211fi
 212
 213case "$resolved" in
 214'')
 215        files=$(git-diff-index --cached --name-only HEAD) || exit
 216        if [ "$files" ]; then
 217           echo "Dirty index: cannot apply patches (dirty: $files)" >&2
 218           exit 1
 219        fi
 220esac
 221
 222if test "$(cat "$dotest/binary")" = t
 223then
 224        binary=--allow-binary-replacement
 225fi
 226if test "$(cat "$dotest/utf8")" = t
 227then
 228        utf8=-u
 229fi
 230if test "$(cat "$dotest/keep")" = t
 231then
 232        keep=-k
 233fi
 234ws=`cat "$dotest/whitespace"`
 235if test "$(cat "$dotest/sign")" = t
 236then
 237        SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
 238                        s/>.*/>/
 239                        s/^/Signed-off-by: /'
 240                `
 241else
 242        SIGNOFF=
 243fi
 244
 245last=`cat "$dotest/last"`
 246this=`cat "$dotest/next"`
 247if test "$skip" = t
 248then
 249        if test -d "$GIT_DIR/rr-cache"
 250        then
 251                git-rerere clear
 252        fi
 253        this=`expr "$this" + 1`
 254        resume=
 255fi
 256
 257if test "$this" -gt "$last"
 258then
 259        echo Nothing to do.
 260        rm -fr "$dotest"
 261        exit
 262fi
 263
 264while test "$this" -le "$last"
 265do
 266        msgnum=`printf "%0${prec}d" $this`
 267        next=`expr "$this" + 1`
 268        test -f "$dotest/$msgnum" || {
 269                resume=
 270                go_next
 271                continue
 272        }
 273
 274        # If we are not resuming, parse and extract the patch information
 275        # into separate files:
 276        #  - info records the authorship and title
 277        #  - msg is the rest of commit log message
 278        #  - patch is the patch body.
 279        #
 280        # When we are resuming, these files are either already prepared
 281        # by the user, or the user can tell us to do so by --resolved flag.
 282        case "$resume" in
 283        '')
 284                git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
 285                        <"$dotest/$msgnum" >"$dotest/info" ||
 286                        stop_here $this
 287                git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
 288                ;;
 289        esac
 290
 291        GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 292        GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 293        GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 294
 295        if test -z "$GIT_AUTHOR_EMAIL"
 296        then
 297                echo "Patch does not have a valid e-mail address."
 298                stop_here $this
 299        fi
 300
 301        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 302
 303        SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
 304        case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
 305
 306        case "$resume" in
 307        '')
 308            if test '' != "$SIGNOFF"
 309            then
 310                LAST_SIGNED_OFF_BY=`
 311                    sed -ne '/^Signed-off-by: /p' \
 312                    "$dotest/msg-clean" |
 313                    tail -n 1
 314                `
 315                ADD_SIGNOFF=`
 316                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 317                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 318                    echo "$SIGNOFF"
 319                }`
 320            else
 321                ADD_SIGNOFF=
 322            fi
 323            {
 324                echo "$SUBJECT"
 325                if test -s "$dotest/msg-clean"
 326                then
 327                        echo
 328                        cat "$dotest/msg-clean"
 329                fi
 330                if test '' != "$ADD_SIGNOFF"
 331                then
 332                        echo "$ADD_SIGNOFF"
 333                fi
 334            } >"$dotest/final-commit"
 335            ;;
 336        *)
 337                case "$resolved$interactive" in
 338                tt)
 339                        # This is used only for interactive view option.
 340                        git-diff-index -p --cached HEAD >"$dotest/patch"
 341                        ;;
 342                esac
 343        esac
 344
 345        resume=
 346        if test "$interactive" = t
 347        then
 348            test -t 0 ||
 349            die "cannot be interactive without stdin connected to a terminal."
 350            action=again
 351            while test "$action" = again
 352            do
 353                echo "Commit Body is:"
 354                echo "--------------------------"
 355                cat "$dotest/final-commit"
 356                echo "--------------------------"
 357                printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 358                read reply
 359                case "$reply" in
 360                [yY]*) action=yes ;;
 361                [aA]*) action=yes interactive= ;;
 362                [nN]*) action=skip ;;
 363                [eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
 364                       action=again ;;
 365                [vV]*) action=again
 366                       LESS=-S ${PAGER:-less} "$dotest/patch" ;;
 367                *)     action=again ;;
 368                esac
 369            done
 370        else
 371            action=yes
 372        fi
 373
 374        if test $action = skip
 375        then
 376                go_next
 377                continue
 378        fi
 379
 380        if test -x "$GIT_DIR"/hooks/applypatch-msg
 381        then
 382                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 383                stop_here $this
 384        fi
 385
 386        echo
 387        echo "Applying '$SUBJECT'"
 388        echo
 389
 390        case "$resolved" in
 391        '')
 392                git-apply $binary --index $ws "$dotest/patch"
 393                apply_status=$?
 394                ;;
 395        t)
 396                # Resolved means the user did all the hard work, and
 397                # we do not have to do any patch application.  Just
 398                # trust what the user has in the index file and the
 399                # working tree.
 400                resolved=
 401                changed="$(git-diff-index --cached --name-only HEAD)"
 402                if test '' = "$changed"
 403                then
 404                        echo "No changes - did you forget to use 'git add'?"
 405                        stop_here_user_resolve $this
 406                fi
 407                unmerged=$(git-ls-files -u)
 408                if test -n "$unmerged"
 409                then
 410                        echo "You still have unmerged paths in your index"
 411                        echo "did you forget to use 'git add'?"
 412                        stop_here_user_resolve $this
 413                fi
 414                apply_status=0
 415                if test -d "$GIT_DIR/rr-cache"
 416                then
 417                        git rerere
 418                fi
 419                ;;
 420        esac
 421
 422        if test $apply_status = 1 && test "$threeway" = t
 423        then
 424                if (fall_back_3way)
 425                then
 426                    # Applying the patch to an earlier tree and merging the
 427                    # result may have produced the same tree as ours.
 428                    changed="$(git-diff-index --cached --name-only HEAD)"
 429                    if test '' = "$changed"
 430                    then
 431                            echo No changes -- Patch already applied.
 432                            go_next
 433                            continue
 434                    fi
 435                    # clear apply_status -- we have successfully merged.
 436                    apply_status=0
 437                fi
 438        fi
 439        if test $apply_status != 0
 440        then
 441                echo Patch failed at $msgnum.
 442                stop_here_user_resolve $this
 443        fi
 444
 445        if test -x "$GIT_DIR"/hooks/pre-applypatch
 446        then
 447                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 448        fi
 449
 450        tree=$(git-write-tree) &&
 451        echo Wrote tree $tree &&
 452        parent=$(git-rev-parse --verify HEAD) &&
 453        commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
 454        echo Committed: $commit &&
 455        git-update-ref -m "$rloga: $SUBJECT" HEAD $commit $parent ||
 456        stop_here $this
 457
 458        if test -x "$GIT_DIR"/hooks/post-applypatch
 459        then
 460                "$GIT_DIR"/hooks/post-applypatch
 461        fi
 462
 463        go_next
 464done
 465
 466rm -fr "$dotest"